;NASM/FASM compatible code
;Tweet86 link: https://tinyurl.com/4ydx2har

last EQU logo
time EQU (logo+2)
best EQU (logo+2+8)
base EQU (pal+25)

ORG 256
 MOV FS,AX
 INT 33H
 MOV AX,13H
 INT 10H

 MOV AL,7
 MOV CL,83*2
 MOV DX,(83+159)*2
 INT 33H
 INC AX;MOV AL,8
 MOV CL,20
 MOV DX,20+159
 INT 33H
 PUSH 0A000H
 POP ES

splash:
 MOV SI,intro
 MOV BX,0A0EFH+8
 MOV CL,16*14+8
.1:
 BT [SI-intro+logo],CX
 SETC BYTE [BX]
 DEC BX
 LOOP .1
 MOV BL,39H
 MOV [BX],BH

 CALL draw
;MOV AX,-1
 MOV [best],AX
 MOV [best+2],AX
 INC AX
 PUSHA
 MOV BX,32
 MOV DX,1606H
 MOV CL,29
 MOV AH,2
 INT 10H
.2:
 LODSB
 MOV AH,0EH
 INT 10H
 INC BX
 LOOP .2
 POPA
 INT 16H

init:
 MOV BP,[FS:46CH]
 MOV BL,0
.0:
 MOV BYTE [BX],16
 INC BL
 JNZ .0
 MOV BL,33H
 MOV CL,10
.1:
 MOV CH,10
.2:
 MOV BYTE [BX],0
 INC BX
 DEC CH
 JNZ .2
 ADD BL,6
 LOOP .1

build:
 PUSH 0A0CDH
 MOV AL,32+25
.1:
 POP BX
 DEC AX
 MOV CL,4
.2:
 DEC BL
 JZ .6
 CMP [BX],CH
 JNZ .2
 PUSH BX
.3:
 MOV [BX],AL
 DEC CX
 JZ .1
 CBW
.4:
 IMUL BP,BP,117
 INC BP
 SHLD SI,BP,10
 AND SI,3
 ADD BL,[SI+direction]
 CMP [BX],CH
 JZ .3
 CMP [BX],AL
 JE .4
 SUB BL,[SI+direction]
 DEC AH
 JNZ .4
 POP BX
 CALL draw
 JMP init
.6:
 CALL draw
;MOV AX,-1
 MOV [time],AX
 MOV [time+2],AX
 INC AX
 MOV BL,88H
.7:
 ADD AL,[BX]
 ADC AH,CH
 DEC BL
 JNZ .7
 CMP AX,[last]
 JE init
 MOV [last],AX

.9:
 PUSH CS
 POP ES

hint:
;PUSHA
 MOV SI,level
 MOV BX,3+8
 MOV DX,0010H
 CALL printStr11
 INC BX;MOV BL,4+8
 MOV CL,16
 CALL printStr
 MOV BL,7
 MOV DX,1522H
.1:
 MOV CL,6
 CALL printStr0
 INC DH;MOV DX,1622H
 JPO .1
;MOV CL,6
;CALL printStr0
;MOV SI,Shuffle
 CALL printStr20
;POPA

nums1:
 MOV SP,0FFFEH
 IN AL,40H
 XCHG DX,AX

 MOV DI,pal
 MOV CX,25
.1:
 ADD DL,96
 MOV AX,200H+26
 JNC .2
 MOV AL,63
.2:
 MOV BYTE [DI+25],8
 STOSB
 LOOP .1

 MOV BH,0
 MOV DX,010BH
;MOV AH,2
 INT 10H

 MOV SI,pal-32
 MOV BX,0A033H
 MOV CL,10
.3:
 CWD
 MOV CH,10
.4:
 MOVZX BP,BYTE [BX]
 CMP BYTE [SI+BP],63
 JNE .5
 INC DH
 MOV AL,[BX]
 CMP AL,[BX-16]
 JE .5
 INC DX
.5:
 ADD BL,16
 DEC CH
 JNZ .4
 MOV AL,DH
;TEST AL,AL
;JZ nums1
 DEC AX
 CMP AL,5;6
.6:
 JA nums1
 INC AX
 PUSH DX
 PUSHA
 MOV BX,4+8
 CALL printNum
 MOV AL," "
 INT 10H
 POPA
 SUB BL,10*16-1
 LOOP .3

 MOV DX,171DH
 MOV BX,7
 MOV CL,10
.7:
 MOV AH,2
 INT 10H
 POP AX
 CALL printNum
 MOV AL," "
 INT 10H
 DEC DX
 DEC DX
 LOOP .7

nums2:
 MOV BX,0A033H
 MOV DX,00309H
 MOV CH,10
.3:
 SUB CL,CL
 SALC
.4:
 MOVZX BP,BYTE [BX]
 CMP BYTE [SI+BP],63
 JNE .5
 INC AX
 MOV AH,[BX]
 CMP AH,[BX-1]
 JE .5
 INC CX
.5:
 INC BX
 TEST BL,15
 JNZ .4
;TEST AL,AL
;JZ nums1
 DEC AX
 CMP AL,5;6
 JA nums1.6
 INC AX
 PUSH CX
 PUSHA
 MOV BX,4+8
 MOV AH,2
 INT 10H
 CALL printNum
 POPA
 ADD DH,2
 DEC CH
 JNZ .3

 MOV DX,151FH
 MOV BX,7
 MOV CL,10
.7:
 MOV AH,2
 INT 10H
 POP AX
 CALL printNum
 SUB DH,2
 LOOP .7

 MOV AX,1
 INT 33H

main:
 CALL setColors

scan:
 PUSHA
 MOV AX,[time+2]
 INC AX
 CWD
 JZ .0
 CALL getTime
 SUB AX,[DI-base+time]
 SBB DX,[DI-base+time+2]
 MOV [time+4],AX
 MOV [DI-base+time+6],DX
.0:
 MOV BX,5+8
 MOV SI,40-8
 CALL printTime
 MOV AX,[best]
 MOV DX,[DI-base+best+2]
 TEST DX,DX
 JS .00
 MOV BL,5
 MOV SI,256+40-8
 CALL printTime
.00:
 POPA

;PUSH CX
;PUSH DX
 MOV AX,3
 INT 33H
 XCHG BX,CX
 SUB BX,35*2
 SHR BX,5
 ADD DX,28
 AND DL,0F0H
 ADD BL,DL
 MOV BH,0A0H
 MOVZX BP,BYTE [BX]
 SUB BP,32
 SHR CX,1
;POP DX
;POP CX
 JNC .2
;PUSHA
.1:
;MOV AX,3
 INT 33H
 SHR BX,1
 JC .1
;POPA
 JMP .4

.2:
 MOV AH,1
 INT 16H
 JZ scan
 MOV AH,0
 INT 16H
 SHR AX,8

 CMP AL,53H
 JNE .22

 MOV DI,pal+25
 MOV AL,8
 MOV CX,25
 REP STOSB
.main:
 JMP main

.22:
 CMP AL,3FH
 JNE .3
 MOV DX,[time+2]
 INC DX
 JZ .10

.3:
 DEC AX
 JZ exit

 DEC AX
 XCHG BP,AX

.4:
 MOV AL,[DI+BP]
 SHR AL,1
 SUB AL,5
 JNC .5
 MOV AL,63
.5:
 MOV [DI+BP],AL
 MOV AX,[time+2]
 INC AX
 JNZ .6

;PUSHA
 MOV SI,reset
 CALL printStr20
;POPA

 CALL getTime
 MOV [time],AX
 MOV [time+2],DX

.6:
 MOV SI,pal
 MOV CX,25
 REPZ CMPSB
 JNE .main

 CALL setColors

 MOV AL,[level+8]
 INC AX
 CMP AL,"9"
 JNA .7
 INC BYTE [DI-base+level+7]
 MOV AL,"0"
.7:
 MOV [level+8],AL

 MOV EAX,[time+4]
 CMP EAX,[DI-base+best]
 JNC .8
 MOV [best],EAX
.8:

 MOV CL,64
.9:
 HLT
 LOOP .9

.10:
 MOV AX,2
 INT 33H
 PUSH 0A000H
 POP ES

 SALC
 MOV CH,128
 REP STOSW
 JMP init

exit:
;MOV AX,3
;INT 10H
 SBB AX,AX
RETN

draw:
 MOV BL,10H
 MOV DI,4*320+32+3
.1:
 MOV AL,[BX+16]
 CMP AL,[BX]
 MOV AL,0
 STOSB
 JE .2
 MOV AL,31
.2:
 MOV CL,15
 REP STOSB
 INC BX
 TEST BL,00FH
 JNZ .1
 ADD DI,64

 MOV AH,15
.3:
 PUSHA
.4:
 MOV AL,[BX-1]
 CMP AL,[BX]
 MOV AL,31
 JNE .5
 SALC
.5:
 STOSB
 MOV AL,[BX]
 MOV CL,15
 REP STOSB
 INC BX
 TEST BL,00FH
 JNZ .4
 POPA
 ADD DI,320
 JC exit
 DEC AH
 JNZ .3
 JMP .1

getTime:
 MOV AH,2CH
 INT 21H
 MOV AL,60
 MUL CL         ; min*60
 SHR DX,8       ; +sec
 ADD AX,DX
 XCHG AX,CX     ; CX=min*60+sec
 SHR AX,8       ; hour
 MOV DX,60*60
 MUL DX         ; DX:AX=hour*60*60
 ADD AX,CX
 ADC DL,DH
RETN

printTime:
 MOV CL,60
 DIV CX
 PUSH DX
 SUB DX,DX
 DIV CX
 PUSH DX
 PUSH AX
 MOV DX,SI
 MOV AH,2
 INT 10H
 POP AX
 TEST AX,AX
 JNZ .1
 MOV AX,0E00H+" "
 INT 10H
 INT 10H
 JMP .2
.1:
 CALL printNum
 MOV AL,":"
.2:
 INT 10H
 POP AX
 CALL printNum2x
 MOV AL,":"
 INT 10H
 POP AX
printNum2x:
 AAM 10
 PUSH AX
 MOV AL,AH
 CALL printNum
 POP AX
printNum:
 ADD AL,"0"
 MOV AH,0EH
 INT 10H
RETN

printStr20:
 MOV BX,20
 MOV DX,180FH
printStr11:
 MOV CX,11
printStr0:
 MOV AH,2
 INT 10H
printStr:
 LODSB
 MOV AH,0EH
 INT 10H
 LOOP printStr
RETN

setColors:
 MOV SI,pal+25
 PUSH SI
 MOV DX,3C8H
 MOV AL,32
 OUT DX,AL
 INC DX
 MOV CL,25
.1:
 LODSB
 OUT DX,AL
 SHR AL,1
 OUT DX,AL
 SHR AL,1
 OUT DX,AL
 LOOP .1
 POP DI
RETN

direction:
 DB -1,-16,1,16

intro:
 DB "Puzzle Game by TomCat/Abaddon"
reset:
 DB " Del: Reset"
level:
 DB "Level 001",10,10
rule1:
 DB 13,"Num of",10,13,"squares"
rule2:
 DB "Num of","blocks"
shuffle:
 DB "F5: Shuffle"

logo:
 DW 0000000000000000B
 DW 0000000000000000B
 DW 1111010111111110B
 DW 0001000000010000B
 DW 0001010111010000B
 DW 0001010101010000B
 DW 0111010001010000B
 DW 0100010001010000B
 DW 0100010001010000B
 DW 0101010001010000B
 DW 0111010001010000B
 DW 0000000000000000B
 DW 0000000000000000B
 DW 0000000000000000B
 DB 0

pal:
